//+------------------------------------------------------------------+
//|                                           UniversalMACrossEA.mq4 |
//|                                  Copyright  2006-2007, firedave | 
//|               Partial Function Copyright  2006-2007, codersguru | 
//|                   Partial Function Copyright  2006-2007, pengie |
//|                                        http://www.fx-review.com/ | 
//|                                        http://www.forex-tsd.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-2007, firedave"
#property link      "http://www.fx-review.com"

/* 

   Discussion at Forex-TSD
   http://www.forex-tsd.com/expert-advisors-metatrader-4/1933-universal-ma-cross-ea.html 

   June 20, 2007 : revise all boolean condition check because of Build 206 bug
*/

//----------------------- INCLUDES
#include <stdlib.mqh>

//----------------------- EA PARAMETER
extern bool             EcnBroker            = false;
extern string           Expert_Name          = "---------- Universal MA Cross EA v1.07";
extern bool             UseAutoMagic         = true;
extern int              ManualMagic          = 19283745;
extern double           StopLoss             = 100,
                        TakeProfit           = 200;
                        
extern string           TrailingStop_Setting = "---------- Trailing Stop Setting";
extern string           tsp4                 = " 4 = Breakeven + Lockin";
extern int              TrailingStopType     = 1;
extern int              TrailingStop         = 40;                     
extern string           ts4                  = "Settings for Type 4";
extern double           BreakEven            = 30;
extern int              LockInPips           = 1;        // Profit Lock in pips

extern string           Indicator_Setting    = "---------- Indicator Setting";
extern int              FastMAPeriod         = 10,
                        FastMAType           = 1,    //0:SMA 1:EMA 2:SMMA 3:LWMA
                        FastMAPrice          = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        FastMAshift          = 0,
                        SlowMAPeriod         = 80,
                        SlowMAType           = 1,    //0:SMA 1:EMA 2:SMMA 3:LWMA
                        SlowMAPrice          = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        SlowMAshift          = 0;
extern bool             UseDema              = true;
extern int              FastDemaPeriod       = 10;
extern int              FastDemaPrice        = PRICE_CLOSE;
extern int              SlowDemaPeriod       = 80;
extern int              SlowDemaPrice        = PRICE_CLOSE;
                        
extern string           CossDistance_Setting = "---------- Min/Max Cross Distance Setting";
extern int              MinCrossDistance     = 0,    //Always positive, 0:disable
                        MinDistanceBarsBack  = 0;    //Number of bar to keep checking for the entry condition
extern int              MaxCrossDistance     = 0,    //Always positive, 0:disable
                        MaxDistanceBarsBack  = 0;    //Number of bar to keep checking for the entry condition
                        
extern string           Exit_Setting         = "---------- Exit Setting";
extern bool             StopAndReverse       = true,  // TURE:if signal change, exit and reverse order
                        PureSAR              = false,  // TRUE:no SL, no TP, no TS
                        ExitOnCross          = false;
                        
extern string           ThirdEMA_Setting     = "---------- Third MA Setting";
extern bool             UseThirdMA           = false,
                        UseCounterTrend      = false,
                        OnlyCounterTrend     = false;
extern int              ThirdMAPeriod        = 100,
                        ThirdMAType          = 1,    //0:SMA 1:EMA 2:SMMA 3:LWMA
                        ThirdMAPrice         = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        ThirdMAshift         = 0,
                        CTStopLoss           = 0,
                        CTTakeProfit         = 0;
                        
extern string           PivotSetting         = "---------- Pivot Filter Setting";
extern bool             UsePivotFilter       = false;
       
extern string           Order_Setting        = "---------- Order Setting";
extern bool             ReverseCondition     = false, // TRUE:buy-sell , sell-buy
                        ConfirmedOnEntry     = true,  // TRUE:entry on the next signal bar
                        OneEntryPerBar       = true;
extern int              NumberOfTries        = 10,
                        Slippage             = 5;
                        
extern string           OpenOrder_Setting    = "---------- Multiple Open Trade Setting";
extern int              MaxOpenTrade         = 1,
                        MinPriceDistance     = 5;
                        
extern string           Time_Parameters      = "---------- EA Active Time";
extern bool             UseHourTrade         = true;
extern int              StartHour            = 3;
extern int              StartMinute          = 0;
extern int              EndHour              = 22;
extern int              EndMinute            = 0;

extern string           MM_Parameters        = "---------- Money Management";
extern double           Lots                 = 1;
extern bool             MM                   = false, //Use Money Management or not
                        AccountIsMicro       = false; //Use Micro-Account or not
extern int              Risk                 = 10;    //10%

extern string           Alert_Setting        = "---------- Alert Setting";
extern bool             EnableAlert          = true;
extern string           SoundFilename        = "alert.wav";

extern string           Testing_Parameters= "---------- Back Test Parameter";
extern bool             PrintControl         = false;
extern bool             Show_Settings        = true;

//----------------------- GLOBAL VARIABLE
static int              TimeFrame            = 0;
string                  TicketComment        = "UniversalMA v1.07",
                        timefilterText       = "",
                        LastTrade,
                        LastAlert,
                        TradeDirection       = "NONE",
                        PreviousDirection    = "NONE",
                        CurrentDirection     = "NONE";
datetime                CheckTime,
                        CheckEntryTime,
                        CrossTime;

double pipMultiplier = 1;
double pPoint;

string s_symbol;

int    MagicNumber;
int    digit;

bool   dummyResult;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   //
   //
   //
   //
   //
   
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic;    
   
	TicketComment  = StringConcatenate(TicketComment, "-", s_symbol, "-", Period());
	if(Show_Settings) subPrintDetails(); 

//----------------------- SET MinCrossDistance ALWAYS POSITIVE
   MinCrossDistance = MathAbs(MinCrossDistance);
   MaxCrossDistance = MathAbs(MaxCrossDistance);

//----------------------- SHOW EA SETTING ON THE CHART
//----------------------- SOURCE : CODERSGURU
   if(Show_Settings==true) subPrintDetails();
   else Comment("");
   
//----------------------- INITIALIZE PURE Stop And Reverse
//----------------------- NO STOP LOSS, NO TAKE PROFIT, NO TRAILING STOP
   if(PureSAR==true)
   {
      StopLoss       = 0;
      TakeProfit     = 0;
      TrailingStop   = 0;
      StopAndReverse = true;
   }

//----------------------- MaxTrade ALWAYS >= 1
   if(MaxOpenTrade<=0) MaxOpenTrade = 1;
   
//+------------------------------------------------------------------+
//| CHECK LAST OPEN TRADE                                            |
//+------------------------------------------------------------------+
   LastTrade = subCheckOpenTrade();
   Print("Last Trade : ",LastTrade);
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   Comment("");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   double FastMACurrent;
   double SlowMACurrent;
   double ThirdMAValue;
   double LastHigh;
   double LastLow;
   double LastClose;
   double P;
   double S1;
   double R1;
   double S2;
   double R2;
                   
   int cnt;
   int ticket;
   int total;
   int shiftCROSS;
   int MaxDistance;
   int MinDistance;
         
   bool BuyCondition = false;
   bool SellCondition = false;
   bool CounterTrend = false;

   string CrossDirection; 
   if(Show_Settings) subPrintDetails();        
   
//----------------------- CHECK CHART NEED MORE THAN 100 BARS
   if(Bars<100) { Print("bars less than 100");  return(0);  }

//----------------------- TRAILING STOP SECTION
   if(TrailingStop>0 && subTotalTrade()>0)
   {
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=OP_SELL &&
            OrderSymbol()==s_symbol && OrderMagicNumber()==MagicNumber)
         {
            subTrailingStop(OrderType());
         }
      }
   }            

//--------------time filter
   if(MM) Lots = subLotSize();
   
   if (UseHourTrade)
   {
    if(!checkTimeLimits(StartHour,StartMinute,0,EndHour,EndMinute,0,TimeCurrent())) 
     {      timefilterText = "Non-Trading Hours!";  
            return(0); 
     }
     else { timefilterText = "Trading Hours!"; }
   }

//----------------------- SET VALUE FOR VARIABLE
   if(ConfirmedOnEntry)
   {
      if(CheckTime   == iTime(s_symbol,TimeFrame,0)) return(0); 
      else CheckTime =  iTime(s_symbol,TimeFrame,0);
      if(UseDema)
      {
        FastMACurrent = iCustom(s_symbol,TimeFrame,"dema",FastDemaPeriod,FastDemaPrice,0,1);
        SlowMACurrent = iCustom(s_symbol,TimeFrame,"dema",SlowDemaPeriod,SlowDemaPrice,0,1);
      }
      else
      {
        FastMACurrent = iMA(s_symbol,TimeFrame,FastMAPeriod,FastMAshift,FastMAType,FastMAPrice,1);
        SlowMACurrent = iMA(s_symbol,TimeFrame,SlowMAPeriod,SlowMAshift,SlowMAType,SlowMAPrice,1);
      }
   }
   else
   {
      if(UseDema)
      {
        FastMACurrent = iCustom(s_symbol,TimeFrame,"dema",FastDemaPeriod,FastDemaPrice,0,0);
        SlowMACurrent = iCustom(s_symbol,TimeFrame,"dema",SlowDemaPeriod,SlowDemaPrice,0,0);
      }
      else
      {
        FastMACurrent = iMA(s_symbol,TimeFrame,FastMAPeriod,FastMAshift,FastMAType,FastMAPrice,0);
        SlowMACurrent = iMA(s_symbol,TimeFrame,SlowMAPeriod,SlowMAshift,SlowMAType,SlowMAPrice,0);
      }
   }
   
   CrossDirection = subCrossDirection(FastMACurrent,SlowMACurrent);

//----------------------- CONDITION CHECK
   if(!ReverseCondition)
   {
//----------------------- BUY CONDITION   
      if(CrossDirection=="UP")
      {
         BuyCondition   = true;
         TradeDirection = "UP";
         CrossTime      = iTime(s_symbol,TimeFrame,0);
      }                       

//----------------------- SELL CONDITION   
      if(CrossDirection=="DOWN")
      {
         SellCondition  = true;
         TradeDirection = "DOWN";
         CrossTime      = iTime(s_symbol,TimeFrame,0);
      }
   }
   else
   {
//----------------------- SELL CONDITION   
      if(CrossDirection=="UP")
      {
         SellCondition  = true;
         TradeDirection = "UP";
         CrossTime      = iTime(s_symbol,TimeFrame,0);
      }                       

//----------------------- BUY CONDITION   
      if(CrossDirection=="DOWN")
      {
         BuyCondition   = true;
         TradeDirection = "DOWN";
         CrossTime      = iTime(s_symbol,TimeFrame,0);
      }
   }                        

   if(PrintControl==true)
   {
      if(BuyCondition==true)  Print("MA Cross BUY");
      if(SellCondition==true) Print("MA Cross SELL");
   }      

//----------------------- ALERT ON CROSS
   if(EnableAlert && ConfirmedOnEntry)
   {
      if(TradeDirection=="UP" && LastAlert!="UP")
      {
         subCrossAlert("UP");
         LastAlert = "UP";
      }            
      if(TradeDirection=="DOWN" && LastAlert!="DOWN")
      {
         subCrossAlert("DOWN");
         LastAlert ="DOWN";
      }
   }                        

//+------------------------------------------------------------------+
//| EXIT BASE ONLY ON MOVING AVERAGE CROSS                           |
//+------------------------------------------------------------------+
if(ExitOnCross && subTotalTrade()>0)
   {
      if((LastTrade=="BUY" && SellCondition) || (LastTrade=="SELL" && BuyCondition))
      {
         subCloseOrder();
         if(subTotalTrade()>0) subCloseOrder();
         if(subTotalTrade()>0) subCloseOrder();
         
         if(IsTesting() && PrintControl==true) Print("EXIT ON CROSS !");
      }
   }

//+------------------------------------------------------------------+
//| CHECKING FOR MIN CROSS DISTANCE SEVERAL BAR AFTER THE CROSS      |
//+------------------------------------------------------------------+
   if(MinDistanceBarsBack>0 && MinCrossDistance>0)
   {
      BuyCondition  = false;
      SellCondition = false;
      shiftCROSS    = iBarShift(s_symbol,TimeFrame,CrossTime);
      MinDistance   = MathFloor(MathAbs((FastMACurrent-SlowMACurrent)/pPoint));
   
      if(shiftCROSS<=MinDistanceBarsBack  && MinDistance>=MinCrossDistance)
      {
         if(ReverseCondition==false)
         {
            if(TradeDirection=="UP")   BuyCondition  = true;
            if(TradeDirection=="DOWN") SellCondition = true;
         }
         else
         {
            if(TradeDirection=="UP")   SellCondition = true;
            if(TradeDirection=="DOWN") BuyCondition  = true;
         }
      }
      
      if(PrintControl==true)
      {
         Print(TimeToStr(CrossTime,TIME_MINUTES)," - ",shiftCROSS," - ",MinDistance," - ",MinCrossDistance," - ",TradeDirection);
         if(BuyCondition==true ) Print("MinCrosDistance BUY");
         if(SellCondition==true) Print("MinCrosDistance SELL");
      }
   }
   
//+------------------------------------------------------------------+
//| CHECKING FOR Max CROSS DISTANCE SEVERAL BAR AFTER THE CROSS      |
//+------------------------------------------------------------------+
   if(MaxDistanceBarsBack>0 && MaxCrossDistance>0)
   {
      BuyCondition  = false;
      SellCondition = false;
      shiftCROSS    = iBarShift(s_symbol,TimeFrame,CrossTime);
      MaxDistance   = MathFloor(MathAbs((FastMACurrent-SlowMACurrent)/pPoint));
   
      if(shiftCROSS<=MaxDistanceBarsBack  && MaxDistance<=MaxCrossDistance)
      {
         if(ReverseCondition==false)
         {
            if(TradeDirection=="UP")   BuyCondition  = true;
            if(TradeDirection=="DOWN") SellCondition = true;
         }
         else
         {
            if(TradeDirection=="UP")   SellCondition = true;
            if(TradeDirection=="DOWN") BuyCondition  = true;
         }
      }
      
      if(PrintControl==true)
      {
         Print(TimeToStr(CrossTime,TIME_MINUTES)," - ",shiftCROSS," - ",MaxDistance," - ",MaxCrossDistance," - ",TradeDirection);
         if(BuyCondition==true ) Print("MaxCrosDistance BUY");
         if(SellCondition==true) Print("MaxCrosDistance SELL");
      }
   }

//+------------------------------------------------------------------+
//| ADDITIONAL FILTER                                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| THIRD MOVING AVERAGE                                             |
//+------------------------------------------------------------------+
   if(UseThirdMA==true)
   {
      ThirdMAValue = iMA(s_symbol,TimeFrame,ThirdMAPeriod,ThirdMAshift,ThirdMAType,ThirdMAPrice,0);

      if(UseCounterTrend==false)
      {      
         if(BuyCondition==true  && SlowMACurrent>ThirdMAValue) BuyCondition  = true; else BuyCondition  = false;
         if(SellCondition==true && SlowMACurrent<ThirdMAValue) SellCondition = true; else SellCondition = false;
      }
      else
      {
         if((BuyCondition==true && FastMACurrent<ThirdMAValue) ||
            (SellCondition==true && FastMACurrent>ThirdMAValue)) CounterTrend = true; else CounterTrend = false;

//+------------------------------------------------------------------+
//| DON'T ALLOW ANY TREND FOLLOWING ENTRY / ONLY COUNTER TREND       |
//+------------------------------------------------------------------+
         if(OnlyCounterTrend==true && CounterTrend==false)
         {
            BuyCondition  = false;
            SellCondition = false;
         }
      }
   }

//+------------------------------------------------------------------+
//| PIVOT FILTER                                                     |
//+------------------------------------------------------------------+
   if(UsePivotFilter)
   {
      LastHigh  = iHigh (s_symbol,PERIOD_D1,1);
      LastLow   = iLow  (s_symbol,PERIOD_D1,1);
      LastClose = iClose(s_symbol,PERIOD_D1,1);
      P         = (LastHigh + LastLow+ LastClose)/3;
      R1        = (2*P)-LastLow;
      S1        = (2*P)-LastHigh;
      R2        = P+(LastHigh - LastLow);
      S2        = P-(LastHigh - LastLow);
      
      if(BuyCondition==true  && SlowMACurrent<=S1 && SlowMACurrent>=S2) BuyCondition  =  true; else BuyCondition  = false;
      if(SellCondition==true && SlowMACurrent>=R1 && SlowMACurrent<=R2) SellCondition =  true; else SellCondition = false;
   }

//+------------------------------------------------------------------+
//| STOP AND REVERSE                                                 |
//+------------------------------------------------------------------+
   if(StopAndReverse==true && subTotalTrade()>0)
   {
      if((LastTrade=="BUY" && SellCondition==true) || (LastTrade=="SELL" && BuyCondition==true))
      {
         subCloseOrder();
         if(subTotalTrade()>0) subCloseOrder();
         if(subTotalTrade()>0) subCloseOrder();

         if(IsTesting() && PrintControl==true) Print("STOP AND REVERSE !");
      }
   }

//----------------------- ENTRY
//----------------------- TOTAL ORDER BASE ON MAGICNUMBER AND SYMBOL
   total = subTotalTrade();

//----------------------- IF NUMBER TRADE LESS THAN MaxTrade
   if(total<MaxOpenTrade && (BuyCondition==true || SellCondition==true)) 
   {

//----------------------- ONE ENTRY PER BAR
      if(OneEntryPerBar==true)
      {
         if(CheckEntryTime   == iTime(s_symbol,TimeFrame,0)) return(0); 
         else CheckEntryTime =  iTime(s_symbol,TimeFrame,0);
      }         

//----------------------- BUY CONDITION   
      if(BuyCondition==true)
      {
         if(MaxOpenTrade>1 && subHighestLowest("BUY")==false) return(0);
      
         if(CounterTrend==false)
         {
            ticket = subOpenOrder(OP_BUY,StopLoss,TakeProfit);
         }
         else
         {
            ticket = subOpenOrder(OP_BUY,CTStopLoss,CTTakeProfit);
         }
         checkErr("Opening BUY",GetLastError());
         LastTrade = "BUY";
         return(0);
      }

//----------------------- SELL CONDITION   
      if(SellCondition==true)
      {
         if(MaxOpenTrade>1 && subHighestLowest("SELL")==false) return(0);
         
         if(CounterTrend==false)
         {
            ticket = subOpenOrder(OP_SELL,StopLoss,TakeProfit);
         }
         else
         {
            ticket = subOpenOrder(OP_SELL,CTStopLoss,CTTakeProfit);
         }
         checkErr("Opening SELL",GetLastError());
         LastTrade = "SELL";
         return(0);
      }
   }
   
return(0);
}

//----------------------- END PROGRAM

//+------------------------------------------------------------------+
//| FUNCTION DEFINITIONS
//+------------------------------------------------------------------+

//----------------------- MONEY MANAGEMENT FUNCTION  
//----------------------- SOURCE : CODERSGURU
double subLotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM <  0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1))  lotMM = 0.5;
	     if(lotMM >  1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM >  100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                  lotMM = Lots;
	     if(lotMM > 1.0)                   lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                   lotMM = 100;
	  }
return (lotMM);
}

//----------------------- NUMBER OF ORDER BASE ON SYMBOL AND MAGICNUMBER FUNCTION
int subTotalTrade()
{
   int cnt;
   int total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      dummyResult = OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==s_symbol &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK OPEN ORDER BASE ON SYMBOL AND MAGIC NUMBER      |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
string subCheckOpenTrade()
{
   int cnt = 0;
   string lasttrade = "None";      

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      dummyResult = OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==s_symbol &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY ) lasttrade = "BUY";
         if(OrderType()==OP_SELL) lasttrade = "SELL";
      }         
   }
   return(lasttrade);
}

//----------------------- FIND LOWEST/HIGHEST BUY-SELL FUNCTION
bool subHighestLowest(string type)
{
   int cnt;
   int total = 0;
      
   double HighestBuy  = 0;
   double LowestBuy   = 10000;
   double HighestSell = 0;
   double LowestSell  = 10000;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      dummyResult = OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==s_symbol &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(NormalizeDouble(OrderOpenPrice(),digit)<LowestBuy ) LowestBuy  = NormalizeDouble(OrderOpenPrice(),digit);
            if(NormalizeDouble(OrderOpenPrice(),digit)>HighestBuy) HighestBuy = NormalizeDouble(OrderOpenPrice(),digit);
         }

         if(OrderType()==OP_SELL)
         {
            if(NormalizeDouble(OrderOpenPrice(),digit)<LowestSell ) LowestSell  = NormalizeDouble(OrderOpenPrice(),digit);
            if(NormalizeDouble(OrderOpenPrice(),digit)>HighestSell) HighestSell = NormalizeDouble(OrderOpenPrice(),digit);
         }

      }
   }
   
   if     (type=="BUY"  && (Ask<=LowestBuy -MinPriceDistance*pPoint || Ask>=HighestBuy +MinPriceDistance*pPoint)) return(true);
   else if(type=="SELL" && (Bid<=LowestSell-MinPriceDistance*pPoint || Bid>=HighestSell+MinPriceDistance*pPoint)) return(true);
   else return(false);
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK IS CROSS OR NOT                                 |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
string subCrossDirection(double fastMA, double slowMA)
{
        if(fastMA>slowMA) CurrentDirection = "UP";
   else if(fastMA<slowMA) CurrentDirection = "DOWN";
   
   if(PreviousDirection=="NONE")
   {
      PreviousDirection = CurrentDirection;
      return("NONE");
   }

   if(PrintControl==true) Print("Prev : ",PreviousDirection," - Curr : ",CurrentDirection);
   
   if(PreviousDirection!=CurrentDirection)
   {
      PreviousDirection = CurrentDirection;
      return(CurrentDirection);
   }
   else return("NONE");
}

//
//
//
//
//

void checkStlTpr(int ticket, double stoploss, double takeprofit)
{
   if (ticket<=0) return;
   
   //
   //
   //
   //
   //
   
   StopLoss   = 0;
   TakeProfit = 0;
   for(int i=0; i<NumberOfTries; i++)
   {
      RefreshRates();
      dummyResult = OrderSelect(ticket,SELECT_BY_TICKET);
         if(stoploss!=0 && OrderType()==OP_BUY)
               StopLoss = NormalizeDouble(OrderOpenPrice()-stoploss*pPoint*pipMultiplier,digit);
         else  StopLoss = NormalizeDouble(OrderOpenPrice()+stoploss*pPoint*pipMultiplier,digit);
         if (takeprofit!=0 && OrderType()==OP_BUY)
               TakeProfit = NormalizeDouble(OrderOpenPrice()+takeprofit*pPoint*pipMultiplier,digit);
         else  TakeProfit = NormalizeDouble(OrderOpenPrice()-takeprofit*pPoint*pipMultiplier,digit);
   
         //
         //
         //
         //
         //

         if (NormalizeDouble(OrderStopLoss(),digit)!=StopLoss || NormalizeDouble(OrderTakeProfit(),digit)!= TakeProfit)
         { 
            dummyResult = OrderModify(ticket,NormalizeDouble(OrderOpenPrice(),digit),StopLoss,TakeProfit,0,CLR_NONE);   
               int err=GetLastError(); checkErr("Modify order error ",err); if (err==0) break; 
               Sleep(5000);
                  continue;
         }
         break;
   }      
}

//
//
//
//
//

int subOpenOrder(int type, int stoploss, int takeprofit)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(stoploss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-stoploss*pPoint*pipMultiplier,digit);
      bStopLoss   = NormalizeDouble(Bid+stoploss*pPoint*pipMultiplier,digit);
   }
   
   if(takeprofit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+takeprofit*pPoint*pipMultiplier,digit);
      bTakeProfit = NormalizeDouble(Bid-takeprofit*pPoint*pipMultiplier,digit);
   }

   //
   //
   //
   //
   //
      
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         if (!EcnBroker)
               dummyResult = OrderSend(s_symbol,OP_BUY,Lots,Ask,Slippage*pipMultiplier,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,Green);
         else  ticket      = OrderSend(s_symbol,OP_BUY,Lots,Ask,Slippage*pipMultiplier,0        ,0          ,TicketComment,MagicNumber,0,Green);
         
         //
         //
         //
         //
         //
               
         err=GetLastError(); checkErr("Open buy",err);
            if (EcnBroker) checkStlTpr(ticket,stoploss,takeprofit);
            else                        
               if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
            break;
      }   
   }
   
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         if (!EcnBroker)
              dummyResult = OrderSend(s_symbol,OP_SELL,Lots,Bid,Slippage*pipMultiplier,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,Red);
         else ticket      = OrderSend(s_symbol,OP_SELL,Lots,Bid,Slippage*pipMultiplier,0        ,0          ,TicketComment,MagicNumber,0,Red);

         //
         //
         //
         //
         //
         
         err=GetLastError(); checkErr("Open sell",err);
            if (EcnBroker) checkStlTpr(ticket,stoploss,takeprofit);
            else                        
               if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
            break;
      }   
   }  
   return(ticket);
}


//----------------------- CLOSE ORDER FUNCTION
void subCloseOrder()
{
   int
         cnt, 
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;

   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==s_symbol && OrderMagicNumber()==MagicNumber)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               for(c=0;c<NumberOfTries;c++)
               {
                  dummyResult = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*pipMultiplier,Violet);
                  err=GetLastError();
                  if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                  {
                     Sleep(5000);
                     continue;
                  }
                  break;
               }   
               break;
               
            case OP_SELL     :
               for(c=0;c<NumberOfTries;c++)
               {
                  dummyResult = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*pipMultiplier,Violet);
                  err=GetLastError();
                  if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                  {
                     Sleep(5000);
                     continue;
                  }
                  break;
               }   
               break;
               
            case OP_BUYLIMIT :
            case OP_BUYSTOP  :
            case OP_SELLLIMIT:
            case OP_SELLSTOP :
               dummyResult = OrderDelete(OrderTicket());
         }
      }
   }      
}

//----------------------- TRAILING STOP FUNCTION
//----------------------- SOURCE   : CODERSGURU
//----------------------- MODIFIED : FIREDAVE
void subTrailingStop(int Type)
{
   RefreshRates();
   if(Type==OP_BUY)   // buy position is opened   
   {
      switch(TrailingStopType)
      {
//----------------------- AFTER PROFIT TRAILING STOP      
         case 1:
            if(Bid-NormalizeDouble(OrderOpenPrice(),digit)>pPoint*TrailingStop*pipMultiplier &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }
            break;
            
//----------------------- TRAILING STOP
         case 2:
            if(Bid>NormalizeDouble(OrderOpenPrice(),digit) &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }
            break;

         case 4:
            BreakEven_TrailingStop (Type);
            break;
//----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
         default:
            if(Bid-NormalizeDouble(OrderOpenPrice(),digit)>pPoint*TrailingStop*pipMultiplier &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }  
      }
   }

   if(Type==OP_SELL)   // sell position is opened   
   {
      switch(TrailingStopType)
      {
//----------------------- AFTER PROFIT TRAILING STOP      
         case 1:
            if(NormalizeDouble(OrderOpenPrice(),digit)-Ask>pPoint*TrailingStop*pipMultiplier)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
            }
            break;
            
//----------------------- TRAILING STOP
         case 2:
            if(NormalizeDouble(OrderOpenPrice(),digit)>Ask)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
            }
            break;

         case 4:
            BreakEven_TrailingStop (Type);
            break;
//----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
         default:
            if(NormalizeDouble(OrderOpenPrice(),digit)-Ask>pPoint*TrailingStop*pipMultiplier)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
         }
      }
   }
}

//+------------------------------------------------------------------+
//|       
//|                                
//|                       
//|                                             
//+------------------------------------------------------------------+

void BreakEven_TrailingStop(int type)
{
   
   if (type==OP_BUY)
   {
     double pBid = MarketInfo(Symbol(), MODE_BID);
     if (pBid-NormalizeDouble(OrderOpenPrice(),digit) > pPoint*BreakEven * pipMultiplier ) 
     {
       double BuyStop = NormalizeDouble(OrderOpenPrice(),digit) + LockInPips * pPoint * pipMultiplier;
       if (digit > 0) BuyStop = NormalizeDouble(BuyStop,digit);
       if (NormalizeDouble(OrderStopLoss(),digit) < BuyStop) 
         dummyResult =OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),BuyStop,NormalizeDouble(OrderTakeProfit(),digit),LightGreen);
		 return;
	 }
  }
  if (type==OP_SELL)
  {
    double pAsk = MarketInfo(Symbol(), MODE_ASK);
    if (NormalizeDouble(OrderOpenPrice(),digit) - pAsk > pPoint*BreakEven  * pipMultiplier) 
    {
       double SellStop = NormalizeDouble(OrderOpenPrice(),digit) - LockInPips * pPoint * pipMultiplier;
       if (digit > 0) SellStop = NormalizeDouble(SellStop, digit);
       if (NormalizeDouble(OrderStopLoss(),digit) > SellStop) 
          dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),SellStop,NormalizeDouble(OrderTakeProfit(),digit),DarkOrange);
		 return;
    }
  }   

}

//
//
//
//
//

void checkErr(string what, int err)
{
     if (err!=0) Print("Error - "+what+" (",err,") ", ErrorDescription(err));
}

//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE
//----------------------- MODIFIED : FIREDAVE
int GetMagic() 
{
   if (StringFind(s_symbol, "CADJPY") >= 0) return(4522221);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(4522222);
   
   if (StringFind(s_symbol, "XAUUSD") >= 0) return(4522231);
   if (StringFind(s_symbol, "XAGUSD") >= 0) return(4522232);
   if (StringFind(s_symbol, "BRENT")  >= 0) return(4522233);
   if (StringFind(s_symbol, "WTI")    >= 0) return(4522234);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(4522241);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(4522242);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(4522251);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(4522261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(4522262);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(4522263);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(4522264);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(4522265);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(4522266);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(4522267);
   if (StringFind(s_symbol, "EURDKK") >= 0) return(4522268);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(4522271);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(4522272);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(4522273);
   if (StringFind(s_symbol, "GBPNZD") >= 0) return(4522274);
   if (StringFind(s_symbol, "GBPCAD") >= 0) return(4522275);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(4522281);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(4522282);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(4522283);
   if (StringFind(s_symbol, "USDDKK") >= 0) return(4522284);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(4522291);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(4522292);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(4522293);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(4522294);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(4522295);
   
return(ManualMagic);
}

//----------------------- PRINT COMMENT FUNCTION
//----------------------- SOURCE : CODERSGURU
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + timefilterText + NL;
   sComment = sComment + sp;
   sComment = sComment + "TakeProfit=" + DoubleToStr(TakeProfit,0) + " | ";
   sComment = sComment + "TrailingStop=" + DoubleToStr(TrailingStop,0) + " | ";
   sComment = sComment + "StopLoss=" + DoubleToStr(StopLoss,0) + NL; 
   sComment = sComment + sp;
   sComment = sComment + "Reverse Entry Condition=" + subBoolToStr(ReverseCondition) + NL;
   sComment = sComment + "Confirmed On Entry=" + subBoolToStr(ConfirmedOnEntry) + NL;
   sComment = sComment + "Stop And Reverse=" + subBoolToStr(StopAndReverse) + NL;
   sComment = sComment + "Pure SAR=" + subBoolToStr(PureSAR) + NL;
   sComment = sComment + sp;
   sComment = sComment + "Lots=" + DoubleToStr(Lots,2) + " | ";
   sComment = sComment + "MM=" + subBoolToStr(MM) + " | ";
   sComment = sComment + "Risk=" + DoubleToStr(Risk,0) + "%" + NL;
   sComment = sComment + sp;
  
   Comment(sComment);
}


//----------------------- BOOLEN VARIABLE TO STRING FUNCTION
//----------------------- SOURCE : CODERSGURU
string subBoolToStr ( bool value)
{
   if(value==true) return ("True");
   else return ("False");
}

//----------------------- ALERT ON MA CROSS
//----------------------- SOURCE : FIREDAVE

void subCrossAlert(string type)
{
   string AlertComment;
   
   if(type=="UP")   AlertComment = "Moving Average Cross UP !";
   if(type=="DOWN") AlertComment = "Moving Average Cross DOWN !";
   
   Alert(AlertComment);
   PlaySound(SoundFilename);
}

//
//
//
//
//

bool checkTimeLimits(uint startHour, uint startMinute, uint startSecond, uint endHour, uint endMinute, uint endSecond, datetime timeToCheck)
{
   bool answer = false;
   MqlDateTime tempTime; TimeToStruct(timeToCheck,tempTime);
      datetime startTime,endTime,checkTime;
               startTime = _ctMinMax(startHour,0,24)    *3600+_ctMinMax(startMinute,0,60) *60+_ctMinMax(startSecond,0,60);
               endTime   = _ctMinMax(endHour,0,24)      *3600+_ctMinMax(endMinute,0,60)   *60+_ctMinMax(endSecond,0,60);
               checkTime = _ctMinMax(tempTime.hour,0,24)*3600+_ctMinMax(tempTime.min,0,60)*60+_ctMinMax(tempTime.sec,0,60);
               
   if (startTime>endTime)
          answer = (checkTime>=startTime || checkTime<=endTime);
   else   answer = (checkTime>=startTime && checkTime<=endTime);
   return(answer);
}
uint _ctMinMax(uint value, uint min, uint max) { return((uint)MathMax(MathMin(value,max),min)); }
